<script setup lang="ts">
import { storeToRefs } from 'pinia'
import { useAccountStore } from '~~/store/account'

interface Props {
  placeholder?: string
  positionShow?: boolean
  rename?: boolean
}
const { placeholder = '', positionShow = true, rename = false } = defineProps<Props>()
const emit = defineEmits(['inputName'])
const account = useAccountStore()
const { full } = storeToRefs(account)
const name = ref(account.data.name)
const errorMessage = reactive({
  name: '',
  position: '',
})
const position = ref(account.data.position)
const submit = () => {
  errorMessage.name = name.value === '' ? 'この項目は必須です' : ''
  errorMessage.position = position.value === '' ? 'この項目は必須です' : ''
  if (!errorMessage.position && !errorMessage.name)
    emit('inputName', name.value, position.value)
}
const RoleArr = ['Student', 'Company0', 'Company1'] as const
</script>

<template>
  <div class="h-screen w-screen fixed top-0 left-0 bg-white/15 blur-customize flex justify-center items-center">
    <div
      class="min-w-1/3 min-h-1/3 max-w-[90vw] flex px-10 py-5 items-center border-2 border-white rounded-2xl bg-blue-400/35 text-white flex-col gap-5"
    >
      <h3 class="text-2xl ">
        {{ (rename && !full) ? 'ニックネームを入力してください' : 'お名前を入力してください' }}
      </h3>
      <div class="w-full flex items-center flex-col gap-2">
        <input v-model="name" type="text" class="w-full text-2xl p-2 text-black" :placeholder="placeholder">
        <p class="text-red-700">
          {{ errorMessage.name }}
        </p>
        <p v-if="positionShow" text-2xl>
          役割
        </p>
        <select v-if="positionShow" id="" v-model="position" name="" class="w-full h-12 text-black text-2xl">
          <option v-for="role in RoleArr" :key="role" :value="role">
            {{ role }}
          </option>>
        </select>
        <p v-if="positionShow" class="text-red-700">
          {{ errorMessage.position }}
        </p>
      </div>
      <button class="ml-auto text-2xl py-2 px-4 border-2 border-white" :onclick="submit">
        決定
      </button>
    </div>
  </div>
</template>

<style scoped>
.blur-customize {
  backdrop-filter: blur(10px);
}
</style>
